> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-en/sdk/domains-api/device/device.getlocation.md).

# Device.getLocation

> Functional API `getCurrentLocation`You can use the same function with this as well.

### Feature description

Get the device's current location once. Use it when you need the current location, such as for maps, weather, or finding stores. To continuously detect location changes, `Device.subscribeLocation`use

If you don't have location permission, `GetCurrentLocationPermissionError`occurs. `Device.getLocation.getPermission()` / `Device.getLocation.openPermissionDialog()`you can check/request permission with

### Type

```ts
Device.getLocation(options: GetCurrentLocationOptions): Promise<Location>;
```

**Params**

```ts
enum Accuracy {
  Lowest = 1, // Error range within about 3KM
  Low = 2, // Error range within about 1KM
  Balanced = 3, // Error range within a few hundred meters
  High = 4, // Error range within about 10M
  Highest = 5,
  BestForNavigation = 6,
}

type GetCurrentLocationOptions = {
  accuracy: Accuracy;
};
```

**Response**

```ts
type Location = {
  accessLocation?: "FINE" | "COARSE"; // Android only
  timestamp: number;
  coords: {
    latitude: number;
    longitude: number;
    altitude: number;
    accuracy: number;
    altitudeAccuracy: number;
    heading: number;
  };
};
```

### Error

The error is thrown as a class — `error instanceof GetCurrentLocationPermissionError`identify it with. The class can `@apps-in-toss/web-framework`be imported from

| Error class                         | Description                                                                                                      |
| ----------------------------------- | ---------------------------------------------------------------------------------------------------------------- |
| `GetCurrentLocationPermissionError` | This means location permission was denied. `Device.getLocation.openPermissionDialog()`You can request again with |

### Example code

```js
import {
  Accuracy,
  Device,
  GetCurrentLocationPermissionError,
} from "@apps-in-toss/web-framework";

async function showCurrentPosition() {
  try {
    const location = await Device.getLocation({ accuracy: Accuracy.Balanced });
    console.log(location.coords.latitude, location.coords.longitude);
  } catch (error) {
    if (error instanceof GetCurrentLocationPermissionError) {
      console.warn("No location permission.");
      return;
    }
    console.error(error);
  }
}

document
  .getElementById("get-location")
  .addEventListener("click", showCurrentPosition);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-en/sdk/domains-api/device/device.getlocation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
